## API Report File for "kibana"

> Do not edit this file. It is a report generated by [API Extractor](https://api-extractor.com/).

```ts

import Boom from 'boom';
import { ByteSizeValue } from '@kbn/config-schema';
import { CallCluster } from 'src/legacy/core_plugins/elasticsearch';
import { ConfigOptions } from 'elasticsearch';
import { Duration } from 'moment';
import { ObjectType } from '@kbn/config-schema';
import { Observable } from 'rxjs';
import { Request } from 'hapi';
import { ResponseObject } from 'hapi';
import { ResponseToolkit } from 'hapi';
import { Schema } from '@kbn/config-schema';
import { Server } from 'hapi';
import { Type } from '@kbn/config-schema';
import { TypeOf } from '@kbn/config-schema';
import { Url } from 'url';

// @public (undocumented)
export type APICaller = (endpoint: string, clientParams: Record<string, unknown>, options?: CallAPIOptions) => Promise<unknown>;

// Warning: (ae-forgotten-export) The symbol "AuthResult" needs to be exported by the entry point index.d.ts
// 
// @public (undocumented)
export type AuthenticationHandler = (request: KibanaRequest, t: AuthToolkit) => AuthResult | Promise<AuthResult>;

// @public
export type AuthHeaders = Record<string, string>;

// @public
export interface AuthResultData {
    headers: AuthHeaders;
    state: Record<string, unknown>;
}

// @public
export interface AuthToolkit {
    authenticated: (data?: Partial<AuthResultData>) => AuthResult;
    redirected: (url: string) => AuthResult;
    rejected: (error: Error, options?: {
        statusCode?: number;
    }) => AuthResult;
}

// Warning: (ae-forgotten-export) The symbol "BootstrapArgs" needs to be exported by the entry point index.d.ts
// 
// @internal (undocumented)
export function bootstrap({ configs, cliArgs, applyConfigOverrides, features, }: BootstrapArgs): Promise<void>;

// @public
export interface CallAPIOptions {
    signal?: AbortSignal;
    wrap401Errors: boolean;
}

// @public
export class ClusterClient {
    constructor(config: ElasticsearchClientConfig, log: Logger, getAuthHeaders?: GetAuthHeaders);
    asScoped(request?: KibanaRequest | LegacyRequest | FakeRequest): ScopedClusterClient;
    callAsInternalUser: (endpoint: string, clientParams?: Record<string, unknown>, options?: CallAPIOptions | undefined) => Promise<any>;
    close(): void;
    }

// @internal (undocumented)
export class ConfigService {
    // Warning: (ae-forgotten-export) The symbol "Config" needs to be exported by the entry point index.d.ts
    // Warning: (ae-forgotten-export) The symbol "Env" needs to be exported by the entry point index.d.ts
    constructor(config$: Observable<Config>, env: Env, logger: LoggerFactory);
    atPath<TSchema>(path: ConfigPath): Observable<TSchema>;
    getConfig$(): Observable<Config>;
    // (undocumented)
    getUnusedPaths(): Promise<string[]>;
    // (undocumented)
    getUsedPaths(): Promise<string[]>;
    // (undocumented)
    isEnabledAtPath(path: ConfigPath): Promise<boolean>;
    optionalAtPath<TSchema>(path: ConfigPath): Observable<TSchema | undefined>;
    // Warning: (ae-forgotten-export) The symbol "ConfigPath" needs to be exported by the entry point index.d.ts
    setSchema(path: ConfigPath, schema: Type<unknown>): Promise<void>;
    }

// @public
export interface CoreSetup {
    // (undocumented)
    elasticsearch: {
        adminClient$: Observable<ClusterClient>;
        dataClient$: Observable<ClusterClient>;
    };
    // (undocumented)
    http: {
        registerOnPreAuth: HttpServiceSetup['registerOnPreAuth'];
        registerAuth: HttpServiceSetup['registerAuth'];
        registerOnPostAuth: HttpServiceSetup['registerOnPostAuth'];
        basePath: HttpServiceSetup['basePath'];
        createNewServer: HttpServiceSetup['createNewServer'];
    };
}

// @public
export interface CoreStart {
}

// @public
export interface DiscoveredPlugin {
    readonly configPath: ConfigPath;
    readonly id: PluginName;
    readonly optionalPlugins: ReadonlyArray<PluginName>;
    readonly requiredPlugins: ReadonlyArray<PluginName>;
}

// Warning: (ae-forgotten-export) The symbol "ElasticsearchConfig" needs to be exported by the entry point index.d.ts
// 
// @public (undocumented)
export type ElasticsearchClientConfig = Pick<ConfigOptions, 'keepAlive' | 'log' | 'plugins'> & Pick<ElasticsearchConfig, 'apiVersion' | 'customHeaders' | 'logQueries' | 'requestHeadersWhitelist' | 'sniffOnStart' | 'sniffOnConnectionFault' | 'hosts' | 'username' | 'password'> & {
    pingTimeout?: ElasticsearchConfig['pingTimeout'] | ConfigOptions['pingTimeout'];
    requestTimeout?: ElasticsearchConfig['requestTimeout'] | ConfigOptions['requestTimeout'];
    sniffInterval?: ElasticsearchConfig['sniffInterval'] | ConfigOptions['sniffInterval'];
    ssl?: Partial<ElasticsearchConfig['ssl']>;
};

// @public (undocumented)
export interface ElasticsearchServiceSetup {
    // (undocumented)
    readonly adminClient$: Observable<ClusterClient>;
    // (undocumented)
    readonly createClient: (type: string, config: ElasticsearchClientConfig) => ClusterClient;
    // (undocumented)
    readonly dataClient$: Observable<ClusterClient>;
    // (undocumented)
    readonly legacy: {
        readonly config$: Observable<ElasticsearchConfig>;
    };
}

// @public
export interface FakeRequest {
    headers: Record<string, string>;
}

// @public
export type GetAuthHeaders = (request: KibanaRequest | Request) => AuthHeaders | undefined;

// @public (undocumented)
export type Headers = Record<string, string | string[] | undefined>;

// Warning: (ae-forgotten-export) The symbol "HttpServerSetup" needs to be exported by the entry point index.d.ts
// 
// @public (undocumented)
export interface HttpServiceSetup extends HttpServerSetup {
    // Warning: (ae-forgotten-export) The symbol "HttpConfig" needs to be exported by the entry point index.d.ts
    // 
    // (undocumented)
    createNewServer: (cfg: Partial<HttpConfig>) => Promise<HttpServerSetup>;
}

// @public (undocumented)
export interface HttpServiceStart {
    isListening: (port: number) => boolean;
}

// @internal (undocumented)
export interface InternalCoreSetup {
    // (undocumented)
    elasticsearch: ElasticsearchServiceSetup;
    // (undocumented)
    http: HttpServiceSetup;
    // (undocumented)
    plugins: PluginsServiceSetup;
}

// @public (undocumented)
export interface InternalCoreStart {
    // (undocumented)
    plugins: PluginsServiceStart;
}

// @public
export class KibanaRequest<Params = unknown, Query = unknown, Body = unknown> {
    // @internal (undocumented)
    protected readonly [requestSymbol]: Request;
    constructor(request: Request, params: Params, query: Query, body: Body, withoutSecretHeaders: boolean);
    // (undocumented)
    readonly body: Body;
    // Warning: (ae-forgotten-export) The symbol "RouteSchemas" needs to be exported by the entry point index.d.ts
    // 
    // @internal
    static from<P extends ObjectType, Q extends ObjectType, B extends ObjectType>(req: Request, routeSchemas?: RouteSchemas<P, Q, B>, withoutSecretHeaders?: boolean): KibanaRequest<P["type"], Q["type"], B["type"]>;
    readonly headers: Headers;
    // (undocumented)
    readonly params: Params;
    // (undocumented)
    readonly query: Query;
    // (undocumented)
    readonly route: RecursiveReadonly<KibanaRequestRoute>;
    // (undocumented)
    readonly url: Url;
    }

// @public
export interface KibanaRequestRoute {
    // (undocumented)
    method: RouteMethod | 'patch' | 'options';
    // (undocumented)
    options: Required<RouteConfigOptions>;
    // (undocumented)
    path: string;
}

// @public
export type LegacyRequest = Request;

// @public
export interface Logger {
    debug(message: string, meta?: LogMeta): void;
    error(errorOrMessage: string | Error, meta?: LogMeta): void;
    fatal(errorOrMessage: string | Error, meta?: LogMeta): void;
    info(message: string, meta?: LogMeta): void;
    // @internal (undocumented)
    log(record: LogRecord): void;
    trace(message: string, meta?: LogMeta): void;
    warn(errorOrMessage: string | Error, meta?: LogMeta): void;
}

// @public
export interface LoggerFactory {
    get(...contextParts: string[]): Logger;
}

// @internal
export class LogLevel {
    // (undocumented)
    static readonly All: LogLevel;
    // (undocumented)
    static readonly Debug: LogLevel;
    // (undocumented)
    static readonly Error: LogLevel;
    // (undocumented)
    static readonly Fatal: LogLevel;
    static fromId(level: LogLevelId): LogLevel;
    // Warning: (ae-forgotten-export) The symbol "LogLevelId" needs to be exported by the entry point index.d.ts
    // 
    // (undocumented)
    readonly id: LogLevelId;
    // (undocumented)
    static readonly Info: LogLevel;
    // (undocumented)
    static readonly Off: LogLevel;
    supports(level: LogLevel): boolean;
    // (undocumented)
    static readonly Trace: LogLevel;
    // (undocumented)
    readonly value: number;
    // (undocumented)
    static readonly Warn: LogLevel;
}

// @public
export interface LogMeta {
    // (undocumented)
    [key: string]: any;
}

// @internal
export interface LogRecord {
    // (undocumented)
    context: string;
    // (undocumented)
    error?: Error;
    // (undocumented)
    level: LogLevel;
    // (undocumented)
    message: string;
    // (undocumented)
    meta?: {
        [name: string]: any;
    };
    // (undocumented)
    timestamp: Date;
}

// Warning: (ae-forgotten-export) The symbol "OnPostAuthResult" needs to be exported by the entry point index.d.ts
// 
// @public (undocumented)
export type OnPostAuthHandler<Params = any, Query = any, Body = any> = (request: KibanaRequest<Params, Query, Body>, t: OnPostAuthToolkit) => OnPostAuthResult | Promise<OnPostAuthResult>;

// @public
export interface OnPostAuthToolkit {
    next: () => OnPostAuthResult;
    redirected: (url: string) => OnPostAuthResult;
    rejected: (error: Error, options?: {
        statusCode?: number;
    }) => OnPostAuthResult;
}

// Warning: (ae-forgotten-export) The symbol "OnPreAuthResult" needs to be exported by the entry point index.d.ts
// 
// @public (undocumented)
export type OnPreAuthHandler<Params = any, Query = any, Body = any> = (request: KibanaRequest<Params, Query, Body>, t: OnPreAuthToolkit) => OnPreAuthResult | Promise<OnPreAuthResult>;

// @public
export interface OnPreAuthToolkit {
    next: () => OnPreAuthResult;
    redirected: (url: string, options?: {
        forward: boolean;
    }) => OnPreAuthResult;
    rejected: (error: Error, options?: {
        statusCode?: number;
    }) => OnPreAuthResult;
}

// @public
export interface Plugin<TSetup, TStart, TPluginsSetup extends Record<PluginName, unknown> = {}, TPluginsStart extends Record<PluginName, unknown> = {}> {
    // (undocumented)
    setup: (core: CoreSetup, plugins: TPluginsSetup) => TSetup | Promise<TSetup>;
    // (undocumented)
    start: (core: CoreStart, plugins: TPluginsStart) => TStart | Promise<TStart>;
    // (undocumented)
    stop?: () => void;
}

// @public
export type PluginInitializer<TSetup, TStart, TPluginsSetup extends Record<PluginName, unknown> = {}, TPluginsStart extends Record<PluginName, unknown> = {}> = (core: PluginInitializerContext) => Plugin<TSetup, TStart, TPluginsSetup, TPluginsStart>;

// @public
export interface PluginInitializerContext<ConfigSchema = unknown> {
    // (undocumented)
    config: {
        create: <T = ConfigSchema>() => Observable<T>;
        createIfExists: <T = ConfigSchema>() => Observable<T | undefined>;
    };
    // (undocumented)
    env: {
        mode: EnvironmentMode;
    };
    // (undocumented)
    logger: LoggerFactory;
}

// @public
export type PluginName = string;

// @public (undocumented)
export interface PluginsServiceSetup {
    // (undocumented)
    contracts: Map<PluginName, unknown>;
    // (undocumented)
    uiPlugins: {
        public: Map<PluginName, DiscoveredPlugin>;
        internal: Map<PluginName, DiscoveredPluginInternal>;
    };
}

// @public (undocumented)
export interface PluginsServiceStart {
    // (undocumented)
    contracts: Map<PluginName, unknown>;
}

// Warning: (ae-forgotten-export) The symbol "RecursiveReadonlyArray" needs to be exported by the entry point index.d.ts
// 
// @public (undocumented)
export type RecursiveReadonly<T> = T extends (...args: any[]) => any ? T : T extends any[] ? RecursiveReadonlyArray<T[number]> : T extends object ? Readonly<{
    [K in keyof T]: RecursiveReadonly<T[K]>;
}> : T;

// @public
export interface RouteConfigOptions {
    authRequired?: boolean;
    tags?: ReadonlyArray<string>;
}

// @public
export type RouteMethod = 'get' | 'post' | 'put' | 'delete';

// @public (undocumented)
export class Router {
    constructor(path: string);
    delete<P extends ObjectType, Q extends ObjectType, B extends ObjectType>(route: RouteConfig<P, Q, B>, handler: RequestHandler<P, Q, B>): void;
    // Warning: (ae-forgotten-export) The symbol "RouteConfig" needs to be exported by the entry point index.d.ts
    // Warning: (ae-forgotten-export) The symbol "RequestHandler" needs to be exported by the entry point index.d.ts
    get<P extends ObjectType, Q extends ObjectType, B extends ObjectType>(route: RouteConfig<P, Q, B>, handler: RequestHandler<P, Q, B>): void;
    getRoutes(): Readonly<RouterRoute>[];
    // (undocumented)
    readonly path: string;
    post<P extends ObjectType, Q extends ObjectType, B extends ObjectType>(route: RouteConfig<P, Q, B>, handler: RequestHandler<P, Q, B>): void;
    put<P extends ObjectType, Q extends ObjectType, B extends ObjectType>(route: RouteConfig<P, Q, B>, handler: RequestHandler<P, Q, B>): void;
    // Warning: (ae-forgotten-export) The symbol "RouterRoute" needs to be exported by the entry point index.d.ts
    // 
    // (undocumented)
    routes: Array<Readonly<RouterRoute>>;
    }

// @public (undocumented)
export interface SavedObject<T extends SavedObjectAttributes = any> {
    // (undocumented)
    attributes: T;
    // (undocumented)
    error?: {
        message: string;
        statusCode: number;
    };
    // (undocumented)
    id: string;
    // (undocumented)
    migrationVersion?: SavedObjectsMigrationVersion;
    // (undocumented)
    references: SavedObjectReference[];
    // (undocumented)
    type: string;
    // (undocumented)
    updated_at?: string;
    // (undocumented)
    version?: string;
}

// @public (undocumented)
export interface SavedObjectAttributes {
    // Warning: (ae-forgotten-export) The symbol "SavedObjectAttribute" needs to be exported by the entry point index.d.ts
    // 
    // (undocumented)
    [key: string]: SavedObjectAttribute | SavedObjectAttribute[];
}

// @public
export interface SavedObjectReference {
    // (undocumented)
    id: string;
    // (undocumented)
    name: string;
    // (undocumented)
    type: string;
}

// @public (undocumented)
export interface SavedObjectsBaseOptions {
    namespace?: string;
}

// @public (undocumented)
export interface SavedObjectsBulkCreateObject<T extends SavedObjectAttributes = any> {
    // (undocumented)
    attributes: T;
    // (undocumented)
    id?: string;
    // (undocumented)
    migrationVersion?: SavedObjectsMigrationVersion;
    // (undocumented)
    references?: SavedObjectReference[];
    // (undocumented)
    type: string;
}

// @public (undocumented)
export interface SavedObjectsBulkGetObject {
    fields?: string[];
    // (undocumented)
    id: string;
    // (undocumented)
    type: string;
}

// @public (undocumented)
export interface SavedObjectsBulkResponse<T extends SavedObjectAttributes = any> {
    // (undocumented)
    saved_objects: Array<SavedObject<T>>;
}

// @public (undocumented)
export interface SavedObjectsBulkResponse<T extends SavedObjectAttributes = any> {
    // (undocumented)
    saved_objects: Array<SavedObject<T>>;
}

// @internal (undocumented)
export class SavedObjectsClient {
    // Warning: (ae-forgotten-export) The symbol "SavedObjectsRepository" needs to be exported by the entry point index.d.ts
    constructor(repository: SavedObjectsRepository);
    bulkCreate<T extends SavedObjectAttributes = any>(objects: Array<SavedObjectsBulkCreateObject<T>>, options?: SavedObjectsCreateOptions): Promise<SavedObjectsBulkResponse<T>>;
    bulkGet<T extends SavedObjectAttributes = any>(objects?: SavedObjectsBulkGetObject[], options?: SavedObjectsBaseOptions): Promise<SavedObjectsBulkResponse<T>>;
    create<T extends SavedObjectAttributes = any>(type: string, attributes: T, options?: SavedObjectsCreateOptions): Promise<SavedObject<T>>;
    delete(type: string, id: string, options?: SavedObjectsBaseOptions): Promise<{}>;
    // (undocumented)
    errors: typeof SavedObjectsErrorHelpers;
    // (undocumented)
    static errors: typeof SavedObjectsErrorHelpers;
    find<T extends SavedObjectAttributes = any>(options: SavedObjectsFindOptions): Promise<SavedObjectsFindResponse<T>>;
    get<T extends SavedObjectAttributes = any>(type: string, id: string, options?: SavedObjectsBaseOptions): Promise<SavedObject<T>>;
    update<T extends SavedObjectAttributes = any>(type: string, id: string, attributes: Partial<T>, options?: SavedObjectsUpdateOptions): Promise<SavedObjectsUpdateResponse<T>>;
}

// Warning: (ae-incompatible-release-tags) The symbol "SavedObjectsClientContract" is marked as @public, but its signature references "SavedObjectsClient" which is marked as @internal
// 
// @public
export type SavedObjectsClientContract = Pick<SavedObjectsClient, keyof SavedObjectsClient>;

// Warning: (ae-missing-release-tag) "SavedObjectsClientWrapperFactory" is exported by the package, but it is missing a release tag (@alpha, @beta, @public, or @internal)
// 
// @public (undocumented)
export type SavedObjectsClientWrapperFactory<Request = unknown> = (options: SavedObjectsClientWrapperOptions<Request>) => SavedObjectsClientContract;

// Warning: (ae-missing-release-tag) "SavedObjectsClientWrapperOptions" is exported by the package, but it is missing a release tag (@alpha, @beta, @public, or @internal)
// 
// @public (undocumented)
export interface SavedObjectsClientWrapperOptions<Request = unknown> {
    // (undocumented)
    client: SavedObjectsClientContract;
    // (undocumented)
    request: Request;
}

// @public (undocumented)
export interface SavedObjectsCreateOptions extends SavedObjectsBaseOptions {
    id?: string;
    // (undocumented)
    migrationVersion?: SavedObjectsMigrationVersion;
    overwrite?: boolean;
    // (undocumented)
    references?: SavedObjectReference[];
}

// @public (undocumented)
export class SavedObjectsErrorHelpers {
    // (undocumented)
    static createBadRequestError(reason?: string): DecoratedError;
    // (undocumented)
    static createEsAutoCreateIndexError(): DecoratedError;
    // (undocumented)
    static createGenericNotFoundError(type?: string | null, id?: string | null): DecoratedError;
    // (undocumented)
    static createInvalidVersionError(versionInput?: string): DecoratedError;
    // (undocumented)
    static createUnsupportedTypeError(type: string): DecoratedError;
    // (undocumented)
    static decorateBadRequestError(error: Error, reason?: string): DecoratedError;
    // (undocumented)
    static decorateConflictError(error: Error, reason?: string): DecoratedError;
    // (undocumented)
    static decorateEsUnavailableError(error: Error, reason?: string): DecoratedError;
    // (undocumented)
    static decorateForbiddenError(error: Error, reason?: string): DecoratedError;
    // (undocumented)
    static decorateGeneralError(error: Error, reason?: string): DecoratedError;
    // (undocumented)
    static decorateNotAuthorizedError(error: Error, reason?: string): DecoratedError;
    // (undocumented)
    static decorateRequestEntityTooLargeError(error: Error, reason?: string): DecoratedError;
    // (undocumented)
    static isBadRequestError(error: Error | DecoratedError): boolean;
    // (undocumented)
    static isConflictError(error: Error | DecoratedError): boolean;
    // (undocumented)
    static isEsAutoCreateIndexError(error: Error | DecoratedError): boolean;
    // (undocumented)
    static isEsUnavailableError(error: Error | DecoratedError): boolean;
    // (undocumented)
    static isForbiddenError(error: Error | DecoratedError): boolean;
    // (undocumented)
    static isInvalidVersionError(error: Error | DecoratedError): boolean;
    // (undocumented)
    static isNotAuthorizedError(error: Error | DecoratedError): boolean;
    // (undocumented)
    static isNotFoundError(error: Error | DecoratedError): boolean;
    // (undocumented)
    static isRequestEntityTooLargeError(error: Error | DecoratedError): boolean;
    // Warning: (ae-forgotten-export) The symbol "DecoratedError" needs to be exported by the entry point index.d.ts
    // 
    // (undocumented)
    static isSavedObjectsClientError(error: any): error is DecoratedError;
}

// @public (undocumented)
export interface SavedObjectsFindOptions extends SavedObjectsBaseOptions {
    // (undocumented)
    defaultSearchOperator?: 'AND' | 'OR';
    // (undocumented)
    fields?: string[];
    // (undocumented)
    hasReference?: {
        type: string;
        id: string;
    };
    // (undocumented)
    page?: number;
    // (undocumented)
    perPage?: number;
    // (undocumented)
    search?: string;
    searchFields?: string[];
    // (undocumented)
    sortField?: string;
    // (undocumented)
    sortOrder?: string;
    // (undocumented)
    type?: string | string[];
}

// @public (undocumented)
export interface SavedObjectsFindResponse<T extends SavedObjectAttributes = any> {
    // (undocumented)
    page: number;
    // (undocumented)
    per_page: number;
    // (undocumented)
    saved_objects: Array<SavedObject<T>>;
    // (undocumented)
    total: number;
}

// @public
export interface SavedObjectsMigrationVersion {
    // (undocumented)
    [pluginName: string]: string;
}

// @public (undocumented)
export interface SavedObjectsService<Request = any> {
    // Warning: (ae-forgotten-export) The symbol "ScopedSavedObjectsClientProvider" needs to be exported by the entry point index.d.ts
    // 
    // (undocumented)
    addScopedSavedObjectsClientWrapperFactory: ScopedSavedObjectsClientProvider<Request>['addClientWrapperFactory'];
    // (undocumented)
    getSavedObjectsRepository(...rest: any[]): any;
    // (undocumented)
    getScopedSavedObjectsClient: ScopedSavedObjectsClientProvider<Request>['getClient'];
    // Warning: (ae-incompatible-release-tags) The symbol "SavedObjectsClient" is marked as @public, but its signature references "SavedObjectsClient" which is marked as @internal
    // 
    // (undocumented)
    SavedObjectsClient: typeof SavedObjectsClient;
    // (undocumented)
    types: string[];
}

// @public (undocumented)
export interface SavedObjectsUpdateOptions extends SavedObjectsBaseOptions {
    // (undocumented)
    references?: SavedObjectReference[];
    version?: string;
}

// Warning: (ae-forgotten-export) The symbol "Omit" needs to be exported by the entry point index.d.ts
// 
// @public (undocumented)
export interface SavedObjectsUpdateResponse<T extends SavedObjectAttributes = any> extends Omit<SavedObject<T>, 'attributes'> {
    // (undocumented)
    attributes: Partial<T>;
}

// @public
export class ScopedClusterClient {
    constructor(internalAPICaller: APICaller, scopedAPICaller: APICaller, headers?: Record<string, string | string[] | undefined> | undefined);
    callAsCurrentUser(endpoint: string, clientParams?: Record<string, unknown>, options?: CallAPIOptions): Promise<unknown>;
    callAsInternalUser(endpoint: string, clientParams?: Record<string, unknown>, options?: CallAPIOptions): Promise<unknown>;
    }

// @public
export interface SessionStorage<T> {
    clear(): void;
    get(): Promise<T | null>;
    set(sessionValue: T): void;
}

// @public
export interface SessionStorageFactory<T> {
    // (undocumented)
    asScoped: (request: KibanaRequest) => SessionStorage<T>;
}


// Warnings were encountered during analysis:
// 
// src/core/server/plugins/plugin_context.ts:34:10 - (ae-forgotten-export) The symbol "EnvironmentMode" needs to be exported by the entry point index.d.ts
// src/core/server/plugins/plugins_service.ts:37:5 - (ae-forgotten-export) The symbol "DiscoveredPluginInternal" needs to be exported by the entry point index.d.ts

```
